/*jshint -W004, -W041, -W103, eqeqeq: false, noempty: false, undef: false, latedef: false, eqnull: true, multistr: true*/
/*global jQuery, $ */
// JavaScript Document

var error = false;

var background = {
	init: function(){
		//cache config	
		var configPass = {			
			apiKey: localStorage.sd_api_key,
			org: localStorage.sd_org_key,
			inst: localStorage.sd_inst_key,
			role: localStorage.sd_user_role,
			url: 'http://api.sherpadesk.com/'
			}; 
        
        if (configPass.org && configPass.inst && configPass.apiKey && configPass.apiKey.length == 32 && !error)
        {
		background.getNewTicketCount(configPass);
        }
					
		}, //End init
		
	//Global AJAX request
	getSherpaDesk: function(config, method, apimethod, data){	
        var methodType;
		if(config.user && config.pass)	{var header = config.user + ':' + config.pass;} 
										else 
										{var header = config.org + '-' + config.inst + ':' + config.apiKey;};		
		var url = config.url;
		if( apimethod != '' ){methodType = apimethod;} else {var methodType = 'GET';};
        
        return $.ajax({
            type: methodType,
            beforeSend: function (xhr) {
                xhr.withCredentials = true;
                xhr.setRequestHeader('Authorization', 'Basic ' + btoa(header));
                },
            url: url + method,
            cache: false,
            data: data, 
            dataType: 'json'   
		}).promise();
		
		},
		
	getNewTicketCount: function(configPass){			
        background.getSherpaDesk(configPass, 'queues?sort_by=tickets_count')
			.then(
				function(results){
                    error = false;
					for (var i=0 ; i < results.length ; i++)
						{
						    if (results[i]["fullname"].toLowerCase().indexOf("new ticket") == 0 && results[i]["tickets_count"] != 0)
						        {
								chrome.browserAction.setBadgeText({
                                    text: results[i]["tickets_count"].toString()
								  });
                                  break;
								  }
								  else
								  {
								  chrome.browserAction.setBadgeText({
									  text: ""
								  });
									}
						}											
                },
            function(e) {
                //error = e.status == 403 || e.status == 404;
                localStorage.removeItem('sd_api_key');
            console.log("fail @ queues");
        }
			); //End Then		
		}
};

background.init();

setInterval(function() {
    background.init();
  }, 120000);


chrome.runtime.onMessageExternal.addListener(
    function (request, sender, sendResponse) {
        if (request) {
            if (request.message) {
                if (request.message == "is_installed") {
                    sendResponse({ is_installed: true });
                }
            }
        }
        return true;
    });